/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!msp430_general_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !msp430_general_operand (operands[1], i1)
      || !msp430_general_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern0 (x3, E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern0 (x3, E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern0 (x3, E_PSImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!msp430_general_dst_nonv_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern2 (x1, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern2 (x1, E_SImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern2 (x1, E_PSImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern3 (x3); /* [-1, 2] */
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!msp430_general_dst_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !msp430_general_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!msp430_general_dst_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !msp430_general_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!msp430_general_dst_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !msp430_general_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!general_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

static int
pattern7 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern8 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern7 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern7 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !msp430_general_dst_nonv_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!general_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

static int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!msp430_general_dst_nonv_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!msp430_general_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !msp430_general_operand (operands[1], i1)
      || !msp430_general_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!msp430_general_dst_operand (operands[0], E_QImode)
          || !msp430_general_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!msp430_general_dst_operand (operands[0], E_HImode)
          || !msp430_general_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!msp430_general_dst_operand (operands[0], E_PSImode)
          || !msp430_general_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern13 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!msp430_general_dst_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!msp430_general_dst_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!msp430_general_dst_operand (operands[0], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x1, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          return pattern12 (x3); /* [-1, 2] */

        case PC:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          res = pattern12 (x3);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x10 = XEXP (x3, 2);
      operands[1] = x10;
      if (!const_0_to_15_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          res = pattern13 ();
          if (res >= 0)
            return res + 6; /* [6, 8] */
          return -1;

        case PC:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          res = pattern13 ();
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!msp430_general_dst_operand (operands[0], E_QImode)
          || !msp430_general_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!msp430_general_dst_operand (operands[0], E_HImode)
          || !msp430_general_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!msp430_general_dst_operand (operands[0], E_PSImode)
          || !msp430_general_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern17 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!msp430_general_dst_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!msp430_general_dst_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!msp430_general_dst_operand (operands[0], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x1, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          return pattern16 (x3); /* [-1, 2] */

        case PC:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          res = pattern16 (x3);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x10 = XEXP (x3, 2);
      operands[1] = x10;
      if (!const_0_to_15_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          res = pattern17 ();
          if (res >= 0)
            return res + 6; /* [6, 8] */
          return -1;

        case PC:
          x7 = XEXP (x1, 2);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          res = pattern17 ();
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PRE_DEC)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (GET_MODE (x3) != E_HImode
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[0], E_HImode))
        return -1;
      return 1; /* push */

    case E_PSImode:
      if (GET_MODE (x3) != E_PSImode
          || GET_MODE (x4) != E_PSImode
          || !register_operand (operands[0], E_PSImode)
          || !
#line 204 "../../../gcc/gcc/config/msp430/msp430.md"
(TARGET_LARGE))
        return -1;
      return 2; /* pusha */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x2) == SUBREG)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (SUBREG_BYTE (x2))
            {
            case 2:
              if (GET_MODE (x2) == E_QImode
                  && msp430_general_dst_operand (operands[0], E_QImode)
                  && msp430_general_operand (operands[1], E_PSImode)
                  && 
#line 326 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
                return 11; /* movqi_topbyte */
              break;

            case 0:
              if (GET_MODE (x2) == E_SImode
                  && msp430_general_dst_nonv_operand (operands[0], E_SImode)
                  && msp430_symbol_operand (operands[1], E_PSImode))
                return 15; /* movsi_s */
              break;

            default:
              break;
            }
        }
      break;

    case MEM:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) == POST_INC)
        {
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) == REG
              && REGNO (x5) == 1)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern15 (x2, E_HImode) == 0)
                    return 4; /* pop */
                  break;

                case E_PSImode:
                  if (pattern15 (x2, E_PSImode) == 0
                      && 
#line 230 "../../../gcc/gcc/config/msp430/msp430.md"
(TARGET_LARGE))
                    return 5; /* popa */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  if (!nonimmediate_operand (operands[0], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  return 94; /* indirect_jump */
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 0);
  operands[3] = x8;
  switch (GET_MODE (operands[1]))
    {
    case E_PSImode:
      if (!nonimmediate_operand (operands[1], E_PSImode)
          || !general_operand (operands[2], E_PSImode))
        return -1;
      *pnum_clobbers = 1;
      return 96; /* cbranchpsi4_real */

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode))
        return -1;
      *pnum_clobbers = 1;
      return 97; /* cbranchqi4_real */

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 98; /* cbranchhi4_real */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_1_to_8_operand (operands[2], E_HImode))
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          if (general_operand (operands[1], E_QImode)
              && 
#line 952 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return 60; /* *msp430.md:948 */
          if (GET_CODE (x6) != SUBREG
              || maybe_ne (SUBREG_BYTE (x6), 0)
              || GET_MODE (x6) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 966 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 61; /* *msp430.md:962 */

        case SIGN_EXTEND:
          if (GET_MODE (x6) != E_PSImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_HImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 981 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 62; /* *msp430.md:977 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) == E_PSImode)
        {
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) == SUBREG
              && known_eq (SUBREG_BYTE (x6), 0)
              && GET_MODE (x6) == E_HImode)
            {
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (register_operand (operands[0], E_PSImode)
                  && GET_MODE (x2) == E_PSImode)
                {
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (general_operand (operands[1], E_QImode))
                    {
                      x5 = XEXP (x2, 1);
                      operands[2] = x5;
                      if (const_1_to_19_operand (operands[2], E_HImode)
                          && 
#line 1004 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
                        return 64; /* *msp430.md:1000 */
                    }
                }
            }
        }
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!msp430_general_dst_nonv_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!general_operand (operands[1], E_HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 1L:
          if (!
#line 1064 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 68; /* extend_and_shift1_hipsi2 */

        case 2L:
          if (!
#line 1075 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 69; /* extend_and_shift2_hipsi2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          if (
#line 1163 "../../../gcc/gcc/config/msp430/msp430.md"
(!msp430x))
            return 72; /* ashlhi3_430 */
          if (!
#line 1186 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 78; /* ashlhi3_430x */

        case 1:
          return 75; /* ashlsi3_const */

        case 2:
          if (!
#line 1186 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 79; /* ashlpsi3_430x */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x4, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[1]))
    {
    case E_PSImode:
      if (!nonimmediate_operand (operands[1], E_PSImode)
          || !general_operand (operands[2], E_PSImode))
        return -1;
      return 96; /* cbranchpsi4_real */

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode))
        return -1;
      return 97; /* cbranchqi4_real */

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode))
        return -1;
      return 98; /* cbranchhi4_real */

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (GET_MODE (x2) != E_HImode)
                return -1;
              if (register_operand (operands[0], E_HImode)
                  && memory_operand (operands[1], E_QImode))
                return 9; /* movqihi */
              if (!msp430_general_dst_operand (operands[0], E_HImode)
                  || !msp430_general_operand (operands[1], E_QImode))
                return -1;
              return 52; /* zero_extendqihi2 */

            case E_PSImode:
              if (GET_MODE (x2) != E_PSImode)
                return -1;
              if (register_operand (operands[0], E_PSImode)
                  && general_operand (operands[1], E_QImode)
                  && 
#line 317 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
                return 10; /* movqipsi */
              if (!msp430_general_dst_operand (operands[0], E_PSImode)
                  || !msp430_general_operand (operands[1], E_HImode)
                  || !
#line 837 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
                return -1;
              return 55; /* zero_extendhipsi2 */

            case E_SImode:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              if (msp430_general_dst_nonv_operand (operands[0], E_SImode))
                {
                  if (nonimmediate_operand (operands[1], E_QImode))
                    return 54; /* zero_extendqisi2 */
                  if (general_operand (operands[1], E_HImode))
                    return 56; /* zero_extendhisi2 */
                }
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_PSImode))
                return -1;
              return 58; /* zero_extendpsisi2 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_PSImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 994 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 63; /* *msp430.md:991 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 93; /* jump */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (msp430_general_dst_operand (operands[0], E_QImode)
              && msp430_general_operand (operands[1], E_QImode))
            return 12; /* movqi */
          break;

        case E_HImode:
          if (msp430_general_dst_operand (operands[0], E_HImode)
              && msp430_general_operand (operands[1], E_HImode))
            return 14; /* movhi */
          break;

        case E_SImode:
          if (msp430_general_dst_nonv_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode))
            return 16; /* movsi_x */
          break;

        case E_PSImode:
          if (msp430_general_dst_operand (operands[0], E_PSImode)
              && msp430_general_operand (operands[1], E_PSImode))
            return 17; /* movpsi */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != SUBREG
          || maybe_ne (SUBREG_BYTE (x2), 0))
        return -1;
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || !
#line 429 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 18; /* movsipsi2 */

        case SYMBOL_REF:
          operands[1] = x4;
          if (!msp430_symbol_operand (operands[1], E_PSImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !
#line 439 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 19; /* *movpsihi2_lo */

        case ZERO_EXTEND:
          if (pattern9 (x2) != 0
              || !
#line 861 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 57; /* zero_extendhisipsi2 */

        case SIGN_EXTEND:
          if (pattern9 (x2) != 0
              || !
#line 1048 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 67; /* extendhipsi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          if (pattern6 (x2) != 0
              || !
#line 349 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 13; /* *movqihipsi */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (msp430_general_dst_operand (operands[0], E_HImode)
                  && GET_MODE (x2) == E_HImode
                  && msp430_general_operand (operands[1], E_QImode))
                return 50; /* extendqihi2 */
              break;

            case E_PSImode:
              if (msp430_general_dst_operand (operands[0], E_PSImode)
                  && GET_MODE (x2) == E_PSImode
                  && msp430_general_operand (operands[1], E_QImode))
                return 51; /* extendqipsi2 */
              break;

            case E_SImode:
              if (GET_MODE (x2) == E_SImode)
                {
                  if (msp430_general_dst_nonv_operand (operands[0], E_SImode)
                      && nonimmediate_operand (operands[1], E_HImode))
                    return 66; /* extendhisi2 */
                  if (register_operand (operands[0], E_SImode)
                      && register_operand (operands[1], E_PSImode)
                      && 
#line 1089 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
                    return 70; /* extendpsisi2 */
                }
              break;

            default:
              break;
            }
          if (GET_CODE (x4) != SUBREG
              || maybe_ne (SUBREG_BYTE (x4), 0)
              || pattern6 (x2) != 0
              || !
#line 939 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 59; /* *msp430.md:936 */

        default:
          return -1;
        }

    case PLUS:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_PSImode:
              if (pattern0 (x2, E_PSImode) == 0)
                return 20; /* addpsi3 */
              break;

            case E_QImode:
              if (pattern0 (x2, E_QImode) == 0)
                return 21; /* addqi3 */
              break;

            case E_HImode:
              if (pattern0 (x2, E_HImode) == 0)
                return 22; /* addhi3 */
              break;

            default:
              break;
            }
          if (register_operand (operands[1], E_SImode)
              && GET_CODE (x3) == SUBREG
              && known_eq (SUBREG_BYTE (x3), 0)
              && GET_MODE (x3) == E_SImode)
            {
              x8 = XEXP (x3, 0);
              operands[0] = x8;
              if (register_operand (operands[0], E_PSImode)
                  && GET_MODE (x2) == E_SImode)
                {
                  operands[2] = x7;
                  if (general_operand (operands[2], E_SImode))
                    return 23; /* addsipsi3 */
                }
            }
          if (!general_operand (operands[1], E_SImode))
            return -1;
          operands[0] = x3;
          if (!msp430_general_dst_nonv_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[2] = x7;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          return 24; /* addsi3 */

        case PLUS:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != ZERO_EXTEND
              || GET_MODE (x7) != E_HImode)
            return -1;
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 2
              || GET_MODE (x9) != E_BImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!msp430_general_dst_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!msp430_general_operand (operands[1], E_HImode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          if (!msp430_general_operand (operands[2], E_HImode))
            return -1;
          return 27; /* addchi4_cy */

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern10 (x2, E_PSImode) != 0)
            return -1;
          return 28; /* subpsi3 */

        case E_QImode:
          if (pattern10 (x2, E_QImode) != 0)
            return -1;
          return 29; /* subqi3 */

        case E_HImode:
          if (pattern10 (x2, E_HImode) != 0)
            return -1;
          return 30; /* subhi3 */

        case E_SImode:
          if (pattern10 (x2, E_SImode) != 0)
            return -1;
          return 31; /* subsi3 */

        default:
          return -1;
        }

    case AND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (pattern5 (x2))
            {
            case 0:
              if (msp430_inv_constgen_operator (operands[2], E_VOIDmode))
                return 32; /* *bicqi_cg */
              if (!msp430_general_operand (operands[2], E_QImode))
                return -1;
              return 38; /* andqi3 */

            case 1:
              if (msp430_inv_constgen_operator (operands[2], E_VOIDmode))
                return 33; /* *bichi_cg */
              if (!msp430_general_operand (operands[2], E_HImode))
                return -1;
              return 39; /* andhi3 */

            case 2:
              if (msp430_inv_constgen_operator (operands[2], E_VOIDmode))
                return 34; /* *bicpsi_cg */
              if (!msp430_general_operand (operands[2], E_PSImode))
                return -1;
              return 40; /* andpsi3 */

            default:
              return -1;
            }

        case NOT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern11 (x2, E_QImode) != 0)
                return -1;
              return 35; /* bicqi3 */

            case E_HImode:
              if (pattern11 (x2, E_HImode) != 0)
                return -1;
              return 36; /* bichi3 */

            case E_PSImode:
              if (pattern11 (x2, E_PSImode) != 0)
                return -1;
              return 37; /* bicpsi3 */

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x4) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!general_operand (operands[1], E_HImode)
              || !immediate_operand (operands[2], E_VOIDmode))
            return -1;
          return 133; /* andneghi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern1 (x1))
        {
        case 0:
          return 41; /* iorqi3 */

        case 1:
          return 42; /* iorhi3 */

        case 2:
          return 43; /* iorpsi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern1 (x1))
        {
        case 0:
          return 44; /* xorqi3 */

        case 1:
          return 45; /* xorhi3 */

        case 2:
          return 46; /* xorpsi3 */

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern5 (x2))
        {
        case 0:
          return 47; /* one_cmplqi2 */

        case 1:
          return 48; /* one_cmplhi2 */

        case 2:
          return 49; /* one_cmplpsi2 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_4 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!msp430_general_dst_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_PSImode))
            return -1;
          return 65; /* truncpsihi2 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 71; /* truncsipsi2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern4 (x1))
        {
        case 0:
          if (
#line 1163 "../../../gcc/gcc/config/msp430/msp430.md"
(!msp430x))
            return 73; /* ashrhi3_430 */
          if (!
#line 1200 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 80; /* ashrhi3_430x */

        case 1:
          return 76; /* ashrsi3_const */

        case 2:
          if (!
#line 1200 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 81; /* ashrpsi3_430x */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern4 (x1))
        {
        case 0:
          if (
#line 1163 "../../../gcc/gcc/config/msp430/msp430.md"
(!msp430x))
            return 74; /* lshrhi3_430 */
          if (!
#line 1214 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 82; /* lshrhi3_430x */

        case 1:
          return 77; /* lshrsi3_const */

        case 2:
          if (!
#line 1214 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x))
            return -1;
          return 83; /* lshrpsi3_430x */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!general_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      return 90; /* call_value_internal */

    case IF_THEN_ELSE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case LT:
        case GEU:
        case LTU:
          operands[0] = x4;
          if (msp430_cmp_operator (operands[0], E_VOIDmode))
            {
              res = recog_3 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x10 = XEXP (x4, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (GET_CODE (x4))
            {
            case NE:
              switch (pattern14 (x2))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 102; /* *bitbranchqi4 */

                case 1:
                  *pnum_clobbers = 1;
                  return 103; /* *bitbranchhi4 */

                case 2:
                  *pnum_clobbers = 1;
                  return 104; /* *bitbranchpsi4 */

                case 3:
                  *pnum_clobbers = 1;
                  return 111; /* *bitbranchqi4 */

                case 4:
                  *pnum_clobbers = 1;
                  return 112; /* *bitbranchhi4 */

                case 5:
                  *pnum_clobbers = 1;
                  return 113; /* *bitbranchpsi4 */

                case 6:
                  *pnum_clobbers = 1;
                  return 114; /* *bitbranchqi4_z */

                case 7:
                  *pnum_clobbers = 1;
                  return 115; /* *bitbranchhi4_z */

                case 8:
                  *pnum_clobbers = 1;
                  return 116; /* *bitbranchpsi4_z */

                case 9:
                  *pnum_clobbers = 1;
                  return 123; /* *bitbranchqi4_z */

                case 10:
                  *pnum_clobbers = 1;
                  return 124; /* *bitbranchhi4_z */

                case 11:
                  *pnum_clobbers = 1;
                  return 125; /* *bitbranchpsi4_z */

                default:
                  return -1;
                }

            case EQ:
              switch (pattern14 (x2))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 105; /* *bitbranchqi4 */

                case 1:
                  *pnum_clobbers = 1;
                  return 106; /* *bitbranchhi4 */

                case 2:
                  *pnum_clobbers = 1;
                  return 107; /* *bitbranchpsi4 */

                case 3:
                  *pnum_clobbers = 1;
                  return 108; /* *bitbranchqi4 */

                case 4:
                  *pnum_clobbers = 1;
                  return 109; /* *bitbranchhi4 */

                case 5:
                  *pnum_clobbers = 1;
                  return 110; /* *bitbranchpsi4 */

                case 6:
                  *pnum_clobbers = 1;
                  return 117; /* *bitbranchqi4_z */

                case 7:
                  *pnum_clobbers = 1;
                  return 118; /* *bitbranchhi4_z */

                case 8:
                  *pnum_clobbers = 1;
                  return 119; /* *bitbranchpsi4_z */

                case 9:
                  *pnum_clobbers = 1;
                  return 120; /* *bitbranchqi4_z */

                case 10:
                  *pnum_clobbers = 1;
                  return 121; /* *bitbranchhi4_z */

                case 11:
                  *pnum_clobbers = 1;
                  return 122; /* *bitbranchpsi4_z */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GT:
        case LE:
        case GTU:
        case LEU:
          operands[0] = x4;
          if (!msp430_reversible_cmp_operator (operands[0], E_VOIDmode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x11 = XEXP (x2, 2);
          if (GET_CODE (x11) != PC)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          if (general_operand (operands[2], E_PSImode)
              && general_operand (operands[1], E_PSImode))
            {
              x9 = XEXP (x7, 0);
              operands[3] = x9;
              *pnum_clobbers = 1;
              return 99; /* cbranchpsi4_reversed */
            }
          if (general_operand (operands[2], E_QImode)
              && general_operand (operands[1], E_QImode))
            {
              x9 = XEXP (x7, 0);
              operands[3] = x9;
              *pnum_clobbers = 1;
              return 100; /* cbranchqi4_reversed */
            }
          if (!general_operand (operands[2], E_HImode)
              || !general_operand (operands[1], E_HImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[3] = x9;
          *pnum_clobbers = 1;
          return 101; /* cbranchhi4_reversed */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          switch (pattern8 (x2, SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1919 "../../../gcc/gcc/config/msp430/msp430.md"
(optimize > 2 && msp430_has_hwmult ()))
                return -1;
              return 142; /* *mulhisi3_inline */

            case 1:
              if (!
#line 1947 "../../../gcc/gcc/config/msp430/msp430.md"
(optimize > 2 && msp430_has_hwmult ()))
                return -1;
              return 144; /* *mulsidi3_inline */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern8 (x2, ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1933 "../../../gcc/gcc/config/msp430/msp430.md"
(optimize > 2 && msp430_has_hwmult ()))
                return -1;
              return 143; /* *umulhisi3_inline */

            case 1:
              if (!
#line 1961 "../../../gcc/gcc/config/msp430/msp430.md"
(optimize > 2 && msp430_has_hwmult ()))
                return -1;
              return 145; /* *umulsidi3_inline */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_6 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!immediate_operand (operands[1], E_VOIDmode))
            return -1;
          switch (XINT (x1, 1))
            {
            case 4:
              if (!register_operand (operands[0], E_VOIDmode))
                return -1;
              return 3; /* pushm */

            case 15:
              if (!immediate_operand (operands[0], E_VOIDmode))
                return -1;
              return 136; /* delay_cycles_32 */

            case 16:
              if (!immediate_operand (operands[0], E_VOIDmode))
                return -1;
              return 137; /* delay_cycles_32x */

            case 17:
              if (!immediate_operand (operands[0], E_VOIDmode))
                return -1;
              return 138; /* delay_cycles_16 */

            case 18:
              if (!immediate_operand (operands[0], E_VOIDmode))
                return -1;
              return 139; /* delay_cycles_16x */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 5)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!immediate_operand (operands[1], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          operands[2] = x4;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          return 6; /* popm */

        case 1:
          switch (XINT (x1, 1))
            {
            case 6:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 7; /* grow_and_swap */

            case 7:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 8; /* swap_and_shrink */

            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 85; /* prologue_start_marker */

            case 1:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 86; /* prologue_end_marker */

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 87; /* epilogue_start_marker */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 88; /* msp430_refsym_need_exit */

            case 8:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 127; /* disable_interrupts */

            case 9:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 128; /* enable_interrupts */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 129; /* push_intr_state */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 130; /* pop_intr_state */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_VOIDmode))
                return -1;
              return 131; /* bic_SR */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_VOIDmode))
                return -1;
              return 132; /* bis_SR */

            case 21:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_VOIDmode))
                return -1;
              return 134; /* delay_cycles_start */

            case 22:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_VOIDmode))
                return -1;
              return 135; /* delay_cycles_end */

            case 19:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 140; /* delay_cycles_2 */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 141; /* delay_cycles_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (GET_MODE (x5) != E_HImode)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != TRUNCATE
              || GET_MODE (x6) != E_BImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != LSHIFTRT
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ZERO_EXTEND
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x7, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 2
              || GET_MODE (x11) != E_BImode)
            return -1;
          x12 = XEXP (x2, 0);
          operands[0] = x12;
          x13 = XEXP (x5, 0);
          operands[1] = x13;
          x14 = XEXP (x5, 1);
          operands[2] = x14;
          x15 = XEXP (x9, 0);
          if (!rtx_equal_p (x15, operands[1]))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
            case MEM:
              if (!msp430_nonimmediate_operand (operands[2], E_HImode))
                return -1;
              x16 = XEXP (x8, 1);
              if (GET_CODE (x16) != ZERO_EXTEND
                  || GET_MODE (x16) != E_SImode
                  || !msp430_general_dst_operand (operands[0], E_HImode)
                  || !msp430_general_operand (operands[1], E_HImode))
                return -1;
              x17 = XEXP (x16, 0);
              operands[3] = x17;
              if (!msp430_nonimmediate_operand (operands[3], E_HImode))
                return -1;
              return 25; /* addhi3_cy */

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (!immediate_operand (operands[2], E_HImode)
                  || !msp430_general_dst_nonv_operand (operands[0], E_HImode)
                  || !general_operand (operands[1], E_HImode))
                return -1;
              x16 = XEXP (x8, 1);
              operands[3] = x16;
              if (!immediate_operand (operands[3], E_VOIDmode))
                return -1;
              return 26; /* addhi3_cy_i */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 3)
            return -1;
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != PC)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != RETURN)
            return -1;
          x18 = XVECEXP (x5, 0, 0);
          operands[0] = x18;
          if (!immediate_operand (operands[0], E_VOIDmode)
              || !
#line 1243 "../../../gcc/gcc/config/msp430/msp430.md"
(!msp430x))
            return -1;
          return 84; /* epilogue_helper */

        case REG:
        case SUBREG:
          operands[0] = x5;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != PC)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE)
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != LABEL_REF)
            return -1;
          x19 = XEXP (x11, 0);
          operands[1] = x19;
          if (!
#line 1381 "../../../gcc/gcc/config/msp430/msp430.md"
(!(flag_pic || flag_pie) && (optimize > 2 || !TARGET_LARGE)))
            return -1;
          return 95; /* tablejump */

        case IF_THEN_ELSE:
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != PC)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 2
              || GET_MODE (x11) != E_BImode)
            return -1;
          x13 = XEXP (x5, 0);
          switch (GET_CODE (x13))
            {
            case NE:
            case EQ:
            case GE:
            case LT:
            case GEU:
            case LTU:
              operands[0] = x13;
              if (msp430_cmp_operator (operands[0], E_VOIDmode))
                {
                  res = recog_5 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              x20 = XEXP (x13, 1);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              switch (GET_CODE (x13))
                {
                case NE:
                  switch (pattern18 (x5))
                    {
                    case 0:
                      return 102; /* *bitbranchqi4 */

                    case 1:
                      return 103; /* *bitbranchhi4 */

                    case 2:
                      return 104; /* *bitbranchpsi4 */

                    case 3:
                      return 111; /* *bitbranchqi4 */

                    case 4:
                      return 112; /* *bitbranchhi4 */

                    case 5:
                      return 113; /* *bitbranchpsi4 */

                    case 6:
                      return 114; /* *bitbranchqi4_z */

                    case 7:
                      return 115; /* *bitbranchhi4_z */

                    case 8:
                      return 116; /* *bitbranchpsi4_z */

                    case 9:
                      return 123; /* *bitbranchqi4_z */

                    case 10:
                      return 124; /* *bitbranchhi4_z */

                    case 11:
                      return 125; /* *bitbranchpsi4_z */

                    default:
                      return -1;
                    }

                case EQ:
                  switch (pattern18 (x5))
                    {
                    case 0:
                      return 105; /* *bitbranchqi4 */

                    case 1:
                      return 106; /* *bitbranchhi4 */

                    case 2:
                      return 107; /* *bitbranchpsi4 */

                    case 3:
                      return 108; /* *bitbranchqi4 */

                    case 4:
                      return 109; /* *bitbranchhi4 */

                    case 5:
                      return 110; /* *bitbranchpsi4 */

                    case 6:
                      return 117; /* *bitbranchqi4_z */

                    case 7:
                      return 118; /* *bitbranchhi4_z */

                    case 8:
                      return 119; /* *bitbranchpsi4_z */

                    case 9:
                      return 120; /* *bitbranchqi4_z */

                    case 10:
                      return 121; /* *bitbranchhi4_z */

                    case 11:
                      return 122; /* *bitbranchpsi4_z */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case GT:
            case LE:
            case GTU:
            case LEU:
              operands[0] = x13;
              if (!msp430_reversible_cmp_operator (operands[0], E_VOIDmode))
                return -1;
              x14 = XEXP (x5, 1);
              if (GET_CODE (x14) != LABEL_REF)
                return -1;
              x21 = XEXP (x5, 2);
              if (GET_CODE (x21) != PC)
                return -1;
              x22 = XEXP (x13, 0);
              operands[1] = x22;
              x20 = XEXP (x13, 1);
              operands[2] = x20;
              if (general_operand (operands[2], E_PSImode)
                  && general_operand (operands[1], E_PSImode))
                {
                  x23 = XEXP (x14, 0);
                  operands[3] = x23;
                  return 99; /* cbranchpsi4_reversed */
                }
              if (general_operand (operands[2], E_QImode)
                  && general_operand (operands[1], E_QImode))
                {
                  x23 = XEXP (x14, 0);
                  operands[3] = x23;
                  return 100; /* cbranchqi4_reversed */
                }
              if (!general_operand (operands[2], E_HImode)
                  || !general_operand (operands[1], E_HImode))
                return -1;
              x23 = XEXP (x14, 0);
              operands[3] = x23;
              return 101; /* cbranchhi4_reversed */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x24 = XEXP (x1, 0);
      if (GET_CODE (x24) != MEM
          || GET_MODE (x24) != E_HImode)
        return -1;
      x25 = XEXP (x24, 0);
      operands[0] = x25;
      if (!general_operand (operands[0], E_VOIDmode))
        return -1;
      x26 = XEXP (x1, 1);
      operands[1] = x26;
      return 89; /* call_internal */

    case RETURN:
      return 91; /* msp430_return */

    case EH_RETURN:
      return 92; /* msp430_eh_epilogue */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 126; /* nop */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (!msp430_general_dst_nonv_operand (operands[0], E_SImode))
            return NULL;
          if (GET_CODE (x3) == SUBREG
              && known_eq (SUBREG_BYTE (x3), 0)
              && GET_MODE (x3) == E_SImode)
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (msp430_symbol_operand (operands[1], E_PSImode)
                  && 
#line 381 "../../../gcc/gcc/config/msp430/msp430.md"
(reload_completed))
                return gen_split_1 (insn, operands);
            }
          operands[1] = x3;
          if (!general_operand (operands[1], E_SImode)
              || !
#line 395 "../../../gcc/gcc/config/msp430/msp430.md"
(reload_completed))
            return NULL;
          return gen_split_2 (insn, operands);

        case PLUS:
          if (GET_MODE (x3) != E_SImode
              || !msp430_nonsubreg_dst_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!msp430_nonsubregnonpostinc_or_imm_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!msp430_nonsubreg_or_imm_operand (operands[2], E_SImode))
            return NULL;
          return gen_split_3 (insn, operands);

        default:
          return NULL;
        }

    case EH_RETURN:
      if (!
#line 1342 "../../../gcc/gcc/config/msp430/msp430.md"
(reload_completed))
        return NULL;
      return gen_split_4 (insn, operands);

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_HImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return NULL;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!general_operand (operands[1], E_QImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != ZERO_EXTEND
      || GET_MODE (x6) != E_HImode)
    return NULL;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_HImode))
    return NULL;
  x8 = XEXP (x6, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_QImode)
      || !
#line 1021 "../../../gcc/gcc/config/msp430/msp430.md"
(REGNO (operands[0]) == REGNO (operands[2]) && REGNO (operands[2]) == REGNO (operands[3])))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_1 (insn, operands);
}
